<script>
import { mapState } from 'vuex';
import { SocketState } from 'colibri-sockets';

import * as websocketsApiRoutes from '~/helpers/api-routes/websockets.js';
import * as helperFilters from '~/helpers/filters.js';
import * as helperColors from '~/helpers/colors.js';

export default {
  name: `admin-websocket-card`,
  props: {
    websocket: { type: Object, required: true },
    idx: { type: Number, required: true },
  },
  data() {
    return {
      showDeleteModal: false,
    }
  },
  computed: {
    ...mapState({
      isAdmin: (state) => state.users.currentUser.roles.includes(`admin`),
    }),
    isDown() {
      return this.websocket.state === SocketState.DISCONNECTED
          || this.websocket.state === SocketState.CLOSED;
    },
    stateColor() {
      return helperColors.WEBSOCKET_STATE_COLORS[this.websocket.state]
          || helperColors.WEBSOCKET_STATE_COLORS.default;
    },
    connectBtnText() {
      return (this.isDown) ? `connect` : `disconnect`;
    },
  },
  filters: {
    capitalize: helperFilters.capitalize,
  },
  methods: {
    async toggleConnection() {
      if (this.isDown) {
        await this.$store.dispatch(`websockets/connectWebsocket`, { name: this.websocket.name });
      } else {
        await this.$store.dispatch(`websockets/disconnectWebsocket`, { name: this.websocket.name });
      }
    },
    closeDeleteModal() {
      this.showDeleteModal = false;
    },
    async deleteWebsocket () {
      const ws = await this.$axios.$delete(websocketsApiRoutes._delete({ id: this.websocket.id }));
      this.$store.commit(`websockets/deleteWebsocket`, { name: this.websocket.name });
      this.closeDeleteModal();
    },
  },
}
</script>

<template>
  <v-card
    class="card mx-auto"
    :color="`grey ${$vuetify.theme.dark ? 'darken' : 'lighten'}-3`"
  >
    <cbr-modal
      v-model="showDeleteModal"
      :title="$t(`admin.websockets.delete.title`)"
      :onCancel="closeDeleteModal"
      :onConfirm="deleteWebsocket"
      confirmColor="red darken-1"
    >
      {{ $t(`admin.websockets.delete.content`, { id: idx + 1 }) }}
    </cbr-modal>

    <v-card-text>
      <v-row no-gutters align="center">
        <v-row no-gutters class="flex-grow-1" align="center">
          <v-badge inline :color="stateColor" />
          <v-row class="flex-grow-1">
            <v-col :cols="12" sm="2">
              <v-list-item two-line>
                <v-list-item-content>
                  <v-list-item-title>{{ $t(`admin.websockets.port`) | capitalize }}</v-list-item-title>
                  <v-list-item-subtitle>{{ websocket.port }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
            </v-col>
            <v-col :cols="12" sm="4">
              <v-list-item two-line>
                <v-list-item-content>
                  <v-list-item-title>{{ $t(`admin.websockets.host`) | capitalize }}</v-list-item-title>
                  <v-list-item-subtitle>{{ websocket.host }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
            </v-col>
          </v-row>
        </v-row>
        <div class="flex-grow-0">
          <v-btn @click="toggleConnection" outlined scolor="primary">
            {{ $t(`admin.websockets.${connectBtnText}`) }}
          </v-btn>
          <v-btn
            v-if="isAdmin"
            icon
            class="ml-2"
            @click="showDeleteModal = true"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
        </div>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<style lang="scss" scoped>
.app-admin__websocket-card__state {
  width: 20px;
  height: 20px;
  border-radius: 50%;
}
</style>
